package com.diagbot.enums;

import com.diagbot.core.KeyedNamed;
import lombok.Setter;

/**
 * @description: 词性类型枚举
 * @author: zhoutg
 * @date: 2021/2/22 13:44
 */
public enum LibTypeEnum implements KeyedNamed {

    disease(100, "疾病"),
    drug(101, "药品通用名"),
    clinical(103, "症状"),
    vital(104, "体格检查项目"),
    vitalRes(105, "体格检查结果"),
    operation(106, "手术和操作"),
    lis(107, "实验室检查套餐"),
    lisDetail(108, "实验室检查子项目"),
    pacs(109, "辅助检查项目"),
    pacsSub(110, "辅助检查子项目"),
    pacsResult(112, "辅助检查结果"),
    transfusion(113, "输血类型"),
    sex(116, "性别"),
    group(117, "人群"),
    otherAllergy(119, "其他过敏原"),
    ylqxjwp(120, "医疗器械及物品"),
    yphxwzlb(301, "药品化学物质类别"),
    ypzlxlb(302, "药品治疗学类别"),
    ypylxlb(303, "药品药理学类别"),
    ypjpxlb(304, "药品解剖学类别"),
    age(410, "年龄"),
    ;

    @Setter
    private int key;

    @Setter
    private String name;

    LibTypeEnum(int key, String name) {
        this.key = key;
        this.name = name;
    }

    public static LibTypeEnum getEnum(int key) {
        for (LibTypeEnum item : LibTypeEnum.values()) {
            if (item.key == key) {
                return item;
            }
        }
        return null;
    }

    public static LibTypeEnum getEnum(String value) {
        for (LibTypeEnum item : LibTypeEnum.values()) {
            if (item.getName().equals(value)) {
                return item;
            }
        }
        return null;
    }

    public static String getName(int key) {
        LibTypeEnum item = getEnum(key);
        return item != null ? item.name : null;
    }

    @Override
    public int getKey() {
        return key;
    }

    @Override
    public String getName() {
        return name;
    }


}
